package lightcontainer.protocol.rules.reader;

import lightcontainer.protocol.ProtocolReader;

public class SigninRule extends ProtocolReader {

    private static final  String PATTERN = "^SIGNIN ([A-Za-z0-9]{2,20}) ([^ !]{5,50})\r\n$";

    // Index du domain dans le tableau de donnée
    private static final int LOGIN = 0;

    //Index du port dans le tableau de donnée
    private static final int PASSWORD = 1;

    public SigninRule() {
        super(PATTERN);
    }


    public class Result extends ProtocolResult {

        private final String login;

        private final String password;

        public Result(String login, String password) {
            super(FileOptions.NONE);
            this.login = login;
            this.password = password;
        }

        public String getLogin() {
            return login;
        }

        public String getPassword() {
            return password;
        }

        public boolean checkCredentials() {
            return getLogin().equals("aa") && getPassword().equals("aaaaa");
        }
    }


    @Override
    protected SigninRule.Result onExecuted(String... data) {
        SigninRule.Result result = new SigninRule.Result(data[LOGIN], data[PASSWORD]);

        // TODO : Création d'une règle d'écriture SIGN_OK et SIGN_ERROR proprement
        if (result.checkCredentials()) {
            result.setResultCommand("SIGN_OK\r\n", ResultCmdReceiver.CLIENT);
        } else {
            result.setResultCommand("SIGN_ERROR\r\n", ResultCmdReceiver.CLIENT);
        }

        return result;
    }
}
