package lightcontainer.storage;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;

public class Repository {

    //static final String CONFIG_FILE_PATH = "../../resources/config.json";

    void save(String filePath, Adapter adapter) {
        if (filePath != null) {
            String jsonAppData = adapter.toString();
            try (BufferedWriter bufferedWriter = Files.newBufferedWriter(Paths.get(filePath), StandardCharsets.UTF_8, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING)) {
                bufferedWriter.write(jsonAppData);
                bufferedWriter.flush();
            } catch (IOException e) {
                System.out.println("Error while saving configuration file !");
            }
        }
    }

    AppData load(String filePath, Adapter adapter) {
        String jsonString = readFile(filePath);
        return adapter.fromString(jsonString);
    }

    private String readFile(String filePath) {
        StringBuilder builder = new StringBuilder();
        try (BufferedReader reader = Files.newBufferedReader(Paths.get(filePath), StandardCharsets.UTF_8)) {
            while (reader.ready()) {
                builder.append(reader.readLine());
            }
        } catch (IOException e) {
            System.out.println("Error while reading configuration file");
            builder.setLength(0);
        }
        return builder.toString();
    }
}
