package lightcontainer.protocol.rules.reader;

import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.rules.reader.HelloRule;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class HelloRuleTest {

    @Test
    public void whenRuleIsRightThenIsExecute() {
        // GIVEN
        ProtocolReader protocolReader = new HelloRule();
        String request = "HELLO bento 42890\r\n";

        // WHEN
        HelloRule.Result ruleResult = protocolReader.execute(request);

        // THEN
        assertEquals("bento", ruleResult.getDomain());
        assertEquals(42890, ruleResult.getPort());
    }

}